//YAHOO.namespace("example.container");
// $Id: yahooWrapper.js 1360 2009-05-29 14:07:33Z hvddool $
// $URL: https://svn.non-gnu.uvt.nl/uvt-dev/tags/sources/meresco/bzv-5.0.2/html/static/yahooWrapper.js $

modules  = new Array();

function clone(node) {
    var tagName = node.tagName;
    var nodeValue = node.nodeValue;

    if(tagName) {
	var cln = document.createElement(tagName);

	var att = node.attributes;
	for(var i = 0; i < att.length; i++)
	    cln.setAttribute(att[i].name, att[i].value);

	var chi = node.childNodes;
	for(var i = 0; i < chi.length; i++)
	    cln.appendChild(clone(chi[i]));

	return cln;
    } else if(nodeValue) {
	return document.createTextNode(nodeValue);
    }
}


function extractRecord(xmlDoc) {
    var rootNode = xmlDoc.documentElement;

    if(rootNode.nodeName=='parsererror') {
	if (console)
	    console.error( rootNode.firstChild.nodeValue);
    	//debugger;
    }

    var data = new Array();
    var fields = rootNode.childNodes;

    for(var i = 0; i < fields.length; i++ ) {
        var field = fields[i];

        if(!field.tagName || field.tagName != 'field')
            continue;

	var datum = new Object();

        var fieldElements = field.childNodes;
        for(var j = 0; j < fieldElements.length; j++ ) {
            var fieldElement = fieldElements[j];
	    var tagName = fieldElement.tagName;

           if(!tagName)
                continue;

            if(tagName == 'label')
		datum.label = fieldElement.childNodes[0].nodeValue;
	    else
		datum.content = fieldElement;
        }
	data.push(datum);
    }
    return data;
}

function presentData(dataArray, widget, index) {
    var tableNode = getElementById('table'+index);
    // Cleanup previous results
    while (tableNode.firstChild) {
	tableNode.removeChild(tableNode.firstChild);
    }

    // DO NOT use e.setAttribute("class", "classname");
    // because IE will ignore the call comletely.
    // In stead use: tableNode.setAttribute(e,className);
    // YAHOO.util.Dom.addClass(tableNode, "recordElementTable");

    // For IE 'tbody' is required
    var tBodyNode  = document.createElement('tbody');
    YAHOO.util.Dom.addClass(tBodyNode, "recordElementTableBody");

    for(var i = 0; i < dataArray.length ; i++) {
        var field =              dataArray[i];
        var rowNode =            document.createElement('tr');
        var thLabelNode =        document.createElement('th');
        var tdContentNode =      document.createElement('td');

	thLabelNode.appendChild(document.createTextNode(field.label));
	rowNode.appendChild(thLabelNode);

	var childNodes = field.content.childNodes;
	for(var j = 0; j < childNodes.length; j++) {
	    if(childNodes[j]) {
		var chi = clone(childNodes[j]);
		tdContentNode.appendChild(chi);
	    }
	}
	rowNode.appendChild(tdContentNode);
	tBodyNode.appendChild(rowNode);
	tableNode.appendChild(tBodyNode);

	// IE Cannot handle the next line, even if it is made conditional.
	//if (console)
	//    console.log ( "classname is: " + YAHOO.util.Dom.get('recordElementLabel-'+index).className);

    }
}

function getContent(widget,recordId,index)
{
    function successHandler(o) {
        var data = extractRecord(o.responseXML);
        presentData(data, widget, index);
    }

    function failureHandler(o) {
        if (console)
            console.log('Meresco:openurl XMLHttpRequest statusText: ' + o.statusText );

        var widgetNode=getElementById("content"+index);
        widgetNode.setAttribute("class","recordElementContentError");
        widget.setBody("Record information could not be retrieved: "+o.statusText);
    }

    var request = YAHOO.util.Connect.asyncRequest('GET',"/record?recordId="+recordId, {
            success:successHandler,
            failure:failureHandler,
            timeout: 15000
        });
}

function generateMoreinfoToggler(index, buttonPreName, recordId){
    var more = "&gt;";
    var less = "&lt;";

    YAHOO.util.Event.onDOMReady(function () {
            modules[index]=new Array();
            modules[index].button =
                new YAHOO.widget.Button({ type: "checkbox",
					  label: more,
					  id: "checkbutton"+index, name: "checkboxfield"+index,
					  value: "1",
					  container: "moduleContainer"+index, checked: false });

            modules[index].widget=new YAHOO.widget.Module("content"+index, { visible: false });
            modules[index].widget.render();

            function onCheckedChange(e) {
                if (e.newValue) {
                    modules[index].button.set('label',less);
                    getContent(modules[index].widget,recordId,index );
                    modules[index].widget.show();
                } else {
                    modules[index].widget.hide();
                    modules[index].button.set('label',more);
                }
                modules[index].widget.render();
            }
            modules[index].button.addListener("checkedChange", onCheckedChange);

	});
}
